unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    procedure aff_labyrinthe ;
    procedure avancer(ligne,colonne : integer) ;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

type lab = array[1..15] of string[40] ;

const l: lab = ('$$$$$$ $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
                '$ $$ $         $$$    $$ $$ $$$$ $ $ $$$',
                '$  $ $$$$$$$$$ $$$$$$        $   $     $',
                '$ $$      $$$$        $$ $$$$$ $$$ $$$$$',
                '$ $  $$ $ $    $$$ $$$$$       $   $$$ $',
                '$ $$ $  $$$ $$$$$$$$$  $ $$ $$$$ $$$ $ $',
                '$    $ $$         $ $ $$$$$ $      $   $',
                '$$$$ $ $$ $$$$ $$$$   $$  $$$ $$$$$$ $$$',
                '$$   $    $ $$ $$   $$$$ $$           $$',
                '$$ $$$$$$$$ $$$$$ $$$$ $ $$ $$$$$ $$$$$$',
                '$$ $                     $$            $',
                '$$ $$$ $$ $$$$$ $$$ $$$ $$$$$$ $$ $ $$ $',
                '$$ $$$ $$ $$    $$$  $$ $$ $$$ $$$$$$$$$',
                '$$     $   $$$$     $$                $$',
                '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ $$$$$$') ;

       dx : array[0..3] of integer = (0,-1,0,1) ;
       dy : array[0..3] of integer = (-1,0,1,0) ;

var  t : lab ;
     trouve : boolean ;

procedure tform1.aff_labyrinthe ;
var ligne,colonne : integer ;
begin
image1.picture.bitmap.canvas.font.size:=8 ;
for ligne:=1 to 15 do
for colonne:=1 to 40 do
    begin
    case t[ligne][colonne] of
      '$' : with image1.picture.bitmap.canvas do
               begin
               brush.Style:=bsSolid ;
               brush.color:=clBlack ;
               pen.color:=clBlack ;
               rectangle((colonne-1)*15,(ligne-1)*15,colonne*15,ligne*15) ;
               end ;
      '*' : with image1.picture.bitmap.canvas do
               begin
               brush.Style:=bsClear ;
               font.color:=clBlue ;
               textOut((colonne-1)*15+5,(ligne-1)*15+2,'*') ;
               end ;
      ' ' : with image1.picture.bitmap.canvas do
               begin
               brush.Style:=bsSolid ;
               brush.color:=clWhite ;
               pen.color:=clWhite ;
               rectangle((colonne-1)*15,(ligne-1)*15,colonne*15,ligne*15) ;
               end ;
      end ;  
    end ;
end ;

procedure tform1.avancer(ligne,colonne : integer) ;
var i  : integer ;
begin
if not trouve then
   if (ligne=1) and (colonne=7) then
      begin
      trouve:=true ;
      edit1.text:='trouv' ;
      end
   else
      begin
      t[ligne][colonne]:='*' ;
      aff_labyrinthe ;image1.refresh ;
      for i:=0 to 3 do
          if t[ligne+dy[i]][colonne+dx[i]]=' ' then
             avancer(ligne+dy[i],colonne+dx[i]) ;
      if not trouve then
         begin
         t[ligne][colonne]:=' ' ;
         aff_labyrinthe ;image1.refresh ;
         end ;
      end ;
   end ;

procedure TForm1.FormCreate(Sender: TObject);
var tb : tbitmap ;
begin
move(l,t,sizeof(l)) ;
trouve:=false ;
tb:=tbitmap.create ;
tb.width:=15*40 ;
tb.height:=15*15 ;  //--- nb d'elems de t ; high(t)
image1.picture.bitmap:=tb ;
image1.autosize:=true ;
aff_labyrinthe ;
end;



procedure TForm1.Button1Click(Sender: TObject);
begin
edit1.text:='recherche en cours...' ;edit1.refresh ;
avancer(15,34) ;
aff_labyrinthe ;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
close ;
end;

end.
 